/* gcripserver : a server for the dol that was posted on abcig
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <netinet/in.h>

#include <sys/select.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define PORT 5173
#define BUFFERSIZE 1024

int main(int argc,char **argv){
	int mysock,addrsize,recieved,file,nbevents,nbfd;
	char buffer[BUFFERSIZE];
	struct sockaddr_in myaddr,gcaddr;
	fd_set selects;
	struct timeval timer;

	if(argc!=2){
		fprintf(stderr,"\tUsage : %s <filename.iso>\n",argv[0]);
		exit(1);
	}

	mysock=socket(AF_INET,SOCK_DGRAM,0);

	file=open(argv[1],O_WRONLY|O_CREAT,S_IRUSR|S_IWUSR);

	bzero(&myaddr,sizeof(myaddr));
	myaddr.sin_family=AF_INET;
	myaddr.sin_addr.s_addr=htonl(INADDR_ANY);
	myaddr.sin_port=htons(PORT);

	bind(mysock,(struct sockaddr *)&myaddr,sizeof(myaddr));

	//get hello message
	bzero(&gcaddr,sizeof(gcaddr));
	addrsize=sizeof(gcaddr);
	recvfrom(mysock,buffer,BUFFERSIZE,0,(struct sockaddr *)&gcaddr,&addrsize);
	sendto(mysock,"ok",2,0,(struct sockaddr *)&gcaddr,addrsize);

	do{
		FD_ZERO(&selects);
		FD_SET(mysock,&selects);
		nbfd=mysock+1;

		timer.tv_sec=10;
		timer.tv_usec=0;

		nbevents=select(nbfd,&selects,NULL,NULL,&timer);

		if(FD_ISSET(mysock,&selects)){
			bzero(&gcaddr,sizeof(gcaddr));
			addrsize=sizeof(gcaddr);
			recieved=recvfrom(mysock,buffer,BUFFERSIZE,0,(struct sockaddr *)&gcaddr,&addrsize);
			write(file,buffer,recieved);
			sendto(mysock,"ok",2,0,(struct sockaddr *)&gcaddr,addrsize);
		}
	} while(nbevents!=0);

	close(mysock);
	close(file);
	return 0;
}
